Index: channels/chan_agent.c
===================================================================
--- channels/chan_agent.c	(revision 113503)
+++ channels/chan_agent.c	(working copy)
@@ -2033,9 +2033,13 @@
 								pos = 0;
 							} else {
 								ast_log(LOG_WARNING, "Extension '%s@%s' is not valid for automatic login of agent '%s'\n", tmpchan, S_OR(context, "default"), p->agent);
+								ast_mutex_unlock(&p->lock);
+								AST_LIST_UNLOCK(&agents);
 								res = ast_streamfile(chan, "invalid", chan->language);
 								if (!res)
 									res = ast_waitstream(chan, AST_DIGIT_ANY);
+								AST_LIST_LOCK(&agents);
+								ast_mutex_lock(&p->lock);
 								if (res > 0) {
 									tmpchan[0] = res;
 									tmpchan[1] = '\0';
